#if !defined(AFX_ELSECURECLIENTASYNCSOCKET_H__32EF52EE_85BC_4027_ACCA_2EF938C905ED__INCLUDED_)
#define AFX_ELSECURECLIENTASYNCSOCKET_H__32EF52EE_85BC_4027_ACCA_2EF938C905ED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ElSecureClientAsyncSocket.h : header file
//

#define	BUFFER_SIZE	16384

/////////////////////////////////////////////////////////////////////////////
// CElSecureClientAsyncSocket command target

class CElSecureAsyncSocket : public CAsyncSocket
{
// Attributes
public:
	BOOL Connected;
	BOOL EnableVersion(int SSLVersion);
	BOOL DisableVersion(int SSLVersion);
	BOOL EnableCipherSuite(int CipherSuite);
	BOOL DisableCipherSuite(int CipherSuite);
	BOOL IsCipherSuiteEnabled(int CipherSuite);
	BOOL IsVersionEnabled(int Version);
	int GetCurrentVersion();
	int GetCurrentCipherSuite();
	BOOL SetCertStorage(HANDLE hCertStorage);		
	BOOL InternalValidate(int* Validity, int* Reason);
	
// Operations
public:
	CElSecureAsyncSocket();
	virtual ~CElSecureAsyncSocket();

	BOOL Connect( LPCTSTR lpszHostAddress, UINT nHostPort );
	int Send( const void* lpBuf, int nBufLen);
	int Receive (void *lpBuf, int nBufLen);
	void Close(void);
	
	void OpenConnectionHandler();
	void CloseConnectionHandler();
	void DataHandler(void* pBuffer, int nSize);
	void ReceiveHandler(void* pBuffer, int nMaxSize, int* pWritten);
	void SendHandler(void *pBuffer, int nSize);
	void CertificateValidateHandler(HANDLE hX509Handle, int *Validate);
	void CertificateNeededHandler (void* pCertificateBuffer, int *nCertificateSize,
		void *pPrivateKeyBuffer, int *nPrivateKeySize, int CertificateType);

// Overrides
public:
	virtual void OnConnect(void);
	virtual void OnReceiveData(int nError);
	virtual void OnClose(int nErrorCode);
	virtual void OnCertificateValidate(HANDLE hX509Handle, int *Validate);
	virtual void OnCertificateNeeded(void *pCertificateBuffer, int *nMaxCertificateSize,
		void *pPrivateKeyBuffer, int *nMaxPrivateKeySize, int CertificateType);
	virtual void OnBeforeConnection(CElSecureAsyncSocket *Socket);
	
// Implementation
protected:
	BOOL DataReceived;
	void* DataBuffer;
	int DataBufferSize;
	int DataNeededSize;
	void* Buffer;
	int BufferSize;
	
	HANDLE hSecureClient;
	BOOL Active;
	void OnConnect(int nErrorCode);
	void OnReceive(int nErrorCode);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ELSECURECLIENTASYNCSOCKET_H__32EF52EE_85BC_4027_ACCA_2EF938C905ED__INCLUDED_)
