#if !defined(AFX_ELSECURECLIENTSOCKET_H__8C816BFB_DCFF_43B0_87F8_9C9541316689__INCLUDED_)
#define AFX_ELSECURECLIENTSOCKET_H__8C816BFB_DCFF_43B0_87F8_9C9541316689__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ElSecureClientSocket.h : header file

#include "SSLBBoxCli.h"

/////////////////////////////////////////////////////////////////////////////
// CElSecureClientSocket command target

#define	BUFFER_SIZE	16384

class CElSecureSocket : public CSocket
{
// Attributes
public:
	BOOL Connected;   

	BOOL EnableVersion(int SSLVersion);
	BOOL DisableVersion(int SSLVersion);
	BOOL EnableCipherSuite(int CipherSuite);
	BOOL DisableCipherSuite(int CipherSuite);
	BOOL IsCipherSuiteEnabled(int CipherSuite);
	BOOL IsVersionEnabled(int Version);
	int GetCurrentVersion();
	int GetCurrentCipherSuite();
	BOOL SetCertStorage(HANDLE hCertStorage);
	BOOL InternalValidate(int *Validity, int *Reason);

// Operations
public:
	CElSecureSocket();
	virtual ~CElSecureSocket();

	BOOL Connect( LPCTSTR lpszHostAddress, UINT nHostPort );
	void Close(void);
	int Send( const void* lpBuf, int nBufLen);
	int Receive( void* lpBuf, int nBufLen);

	void OpenConnectionHandler(void);
	void CloseConnectionHandler(void);
	void SendHandler(void *pBuffer, int nSize);
	void ReceiveHandler(void *pBuffer, int nMaxSize, int *pWritten);
	void DataHandler(void *pBuffer, int nSize);
	void CertificateValidateHandler(HANDLE hX509Handle, int *Validate);
	void CertificateNeededHandler (void* pCertificateBuffer, int *nCertificateSize,
		void *pPrivateKeyBuffer, int *nPrivateKeySize, int CertificateType);

// Overrides
public:
	virtual void OnConnect(int nErrorCode);
	virtual void OnReceiveData(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	virtual void OnCertificateValidate(HANDLE hX509Handle, int *Validate);
	virtual void OnCertificateNeeded(void *pCertificateBuffer, int *nMaxCertificateSize,
		void *pPrivateKeyBuffer, int *nMaxPrivateKeySize, int CertificateType);
	virtual void OnBeforeConnection(CElSecureSocket *Socket);

// Implementation
protected:
	HANDLE hSecureClient;
	BOOL Active;
	BOOL DataReceived;
	void* DataBuffer;
	int DataBufferSize;
	int DataNeededSize;
	void* Buffer;
	int BufferSize;
	void OnReceive(int nErrorCode);
	int SendTo(const void *lpBuf, int nBufLen, const SOCKADDR *lpSockAddr, int nSockAddrLen);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ELSECURECLIENTSOCKET_H__8C816BFB_DCFF_43B0_87F8_9C9541316689__INCLUDED_)
