VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmSSLOptions 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SSL options"
   ClientHeight    =   3990
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5775
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   266
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   385
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2160
      TabIndex        =   7
      Top             =   3480
      Width           =   1455
   End
   Begin VB.Frame gbSSLOptions 
      Caption         =   "SSL options"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5535
      Begin VB.TextBox tbPassword 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   600
         PasswordChar    =   "*"
         TabIndex        =   9
         Top             =   2640
         Width           =   1935
      End
      Begin MSComDlg.CommonDialog Dlg 
         Left            =   4200
         Top             =   360
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
         DefaultExt      =   "pfx"
         DialogTitle     =   "Certificate select"
         Filter          =   "PKCS#12 files (*.pfx)|*.pfx"
         InitDir         =   "."
      End
      Begin VB.CheckBox cbDisableSSL2 
         Caption         =   "Disable SSLv2"
         Height          =   255
         Left            =   360
         TabIndex        =   6
         Top             =   1200
         Value           =   1  'Checked
         Width           =   1815
      End
      Begin VB.CommandButton btnBrowseCert 
         Caption         =   ".."
         Height          =   280
         Left            =   4920
         TabIndex        =   5
         Top             =   2040
         Width           =   280
      End
      Begin VB.TextBox tbCertPath 
         Height          =   285
         Left            =   600
         Locked          =   -1  'True
         TabIndex        =   4
         Top             =   2040
         Width           =   4335
      End
      Begin VB.CheckBox cbUseCertificate 
         Caption         =   "Use certificate for client authentication"
         Height          =   255
         Left            =   360
         TabIndex        =   3
         Top             =   1680
         Width           =   3375
      End
      Begin VB.CheckBox cbDisableAnonSuites 
         Caption         =   "Disable anonymous ciphersuites"
         Height          =   255
         Left            =   360
         TabIndex        =   2
         Top             =   840
         Value           =   1  'Checked
         Width           =   2655
      End
      Begin VB.CheckBox cbAcceptAllCerts 
         Caption         =   "Accept all certificates"
         Height          =   255
         Left            =   360
         TabIndex        =   1
         Top             =   480
         Width           =   3255
      End
      Begin VB.Label lPassword 
         Caption         =   "Password:"
         Height          =   255
         Left            =   600
         TabIndex        =   8
         Top             =   2400
         Width           =   1935
      End
   End
End
Attribute VB_Name = "frmSSLOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public SSLAcceptAllCerts As Boolean
Public SSLDisableAnonCiphers As Boolean
Public SSLDisableSSL2 As Boolean
Public SSLUseCertificate As Boolean
Public SSLCertificate As IElCertificateX5

Private Sub btnBrowseCert_Click()
    Call Dlg.ShowOpen
    If Err <> 32755 Then
        tbCertPath.Text = Dlg.FileName
        cbUseCertificate.value = Checked
    End If
    On Error GoTo 0
End Sub
Private Function Str2ByteArr(ByVal S As String) As Variant
  Dim i As Integer
  Dim arr() As Byte
  
  ReDim arr(0 To Len(S) - 1)
  
  For i = 0 To Len(S) - 1
      arr(i) = Asc(Mid(S, i + 1, 1))
  Next
  
  Str2ByteArr = arr
End Function

Function OpenFileForRead(ByRef File As Integer, ByVal FileName As String) As Boolean
  Let File = FreeFile()
  Open FileName For Binary Access Read As File
End Function

Sub BlockRead(ByVal File As Integer, _
  ByRef Buffer As Variant, _
  ByVal Count As Long)
  
  Dim S As String
 
  S = Input(Count, File)
  If Len(S) = 0 Then
    Buffer = Empty
  Else
    Buffer = Str2ByteArr(S)
  End If
End Sub

Private Function LoadCertificate() As Boolean
Dim infile As Integer
Dim Buf As Variant
Dim R As Integer
Dim msg As String
    On Error GoTo HandleErr
    
    Call OpenFileForRead(infile, Dlg.FileName)
    Size = LOF(infile)
    Call BlockRead(infile, Buf, Size)
    Close infile
    
    Call SSLCertificate.LoadFromBufferPFX(Buf, tbPassword.Text)
    LoadCertificate = True
    Exit Function
        
HandleErr:
    msg = Err.Description
    MsgBox "Failed to load certificate: " & msg
    LoadCertificate = False
End Function

Private Sub btnOK_Click()
Dim b As Boolean
    If cbUseCertificate.value = Checked Then
        b = LoadCertificate
    Else
        b = True
    End If
    
    SSLAcceptAllCerts = (cbAcceptAllCerts.value = Checked)
    SSLDisableAnonCiphers = (cbDisableAnonSuites.value = Checked)
    SSLDisableSSL2 = (cbDisableSSL2.value = Checked)
    SSLUseCertificate = b And (cbUseCertificate.value = Checked)
    
    If b Then
        Hide
    End If
End Sub

Private Sub Form_Load()
    Set SSLCertificate = CreateObject("PKIBBox.ElCertificateX")
End Sub
