#include "SSLBBoxSrv.h"

#define DLL_NAME				"SSLBBoxSrv.dll"

#define DLL_ROUTINE_COUNT		40

// vvvvv MUST BE RENAMED vvvvv
static HMODULE hDll = NULL;
static LONG nDllRefs = 0;

static FARPROC aDllRoutines[DLL_ROUTINE_COUNT] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
};

static LPTSTR aDllRoutineNames[DLL_ROUTINE_COUNT] = {
	TEXT("SBServerCreate"),
	TEXT("SBServerDestroy"),
	TEXT("SBServerOpen"),
	TEXT("SBServerClose"),
	TEXT("SBServerDataAvailable"),
	TEXT("SBServerEnable"),
	TEXT("SBServerDisable"),
	TEXT("SBServerEnableCipherSuite"),
	TEXT("SBServerDisableCipherSuite"),
	TEXT("SBServerEnableVersion"),
	TEXT("SBServerDisableVersion"),
	TEXT("SBServerGetCurrentVersion"),
	TEXT("SBServerIsEnabled"),
	TEXT("SBServerIsActive"),
	TEXT("SBServerIsCipherSuiteEnabled"),
	TEXT("SBServerIsVersionEnabled"),
	TEXT("SBServerGetCipherSuite"),
	TEXT("SBServerSendData"),
	TEXT("SBServerSetOnData"),
	TEXT("SBServerSetOnReceive"),
	TEXT("SBServerSetOnSend"),
	TEXT("SBServerSetOnOpenConnection"),
	TEXT("SBServerSetOnCloseConnection"),
	TEXT("SBServerSetOnCertificateValidate"),
	TEXT("SBServerInternalValidate"),
	TEXT("SBServerSetCertStorage"),
	TEXT("SBServerSetSessionPool"),
	TEXT("SBServerSetClientCertStorage"),
	TEXT("SBServerEnableClientAuthentication"),
	TEXT("SBServerDisableClientAuthentication"),
	TEXT("SBServerIsClientAuthenticationEnabled"),
	TEXT("SBServerEnableForceCertificateChain"),
	TEXT("SBServerDisableForceCertificateChain"),
	TEXT("SBServerIsForceCertificateChainEnabled"),
	TEXT("SBSessionPoolCreate"),
	TEXT("SBSessionPoolDestroy"),
	TEXT("SBSessionPoolSetTimeout"),
	TEXT("SBSessionPoolSetInterval"),
	TEXT("SBSessionPoolSetMaxCount"),
	TEXT("SetLicenseKey")
};


typedef HANDLE (__stdcall *SBServerCreateProc)(void);
typedef BOOL (__stdcall *SBServerDestroyProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerOpenProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerCloseProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerDataAvailableProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerEnableProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerDisableProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerEnableCipherSuiteProc)(HANDLE hServer, int nSuite);
typedef BOOL (__stdcall *SBServerDisableCipherSuiteProc)(HANDLE hServer, int nSuite);
typedef BOOL (__stdcall *SBServerEnableVersionProc)(HANDLE hServer, int nVersion);
typedef BOOL (__stdcall *SBServerDisableVersionProc)(HANDLE hServer, int nVersion);
typedef int	(__stdcall *SBServerGetCurrentVersionProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerIsEnabledProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerIsActiveProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerIsCipherSuiteEnabledProc)(HANDLE hServer, int nSuite);
typedef BOOL (__stdcall *SBServerIsVersionEnabledProc)(HANDLE hServer, int nVersion);
typedef int	(__stdcall *SBServerGetCipherSuiteProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerSendDataProc)(HANDLE hServer, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBServerSetOnDataProc)(HANDLE hServer, OnSendProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerSetOnReceiveProc)(HANDLE hServer, OnReceiveProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerSetOnSendProc)(HANDLE hServer, OnSendProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerSetOnOpenConnectionProc)(HANDLE hServer, OnOpenConnectionProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerSetOnCloseConnectionProc)(HANDLE hServer, OnCloseConnectionProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerSetOnCertificateValidateProc)(HANDLE hServer, OnCertificateValidateProc pHandler, int nUserData);
typedef BOOL (__stdcall *SBServerInternalValidateProc)(HANDLE hServer, int* Validity, int* Reason);
typedef BOOL (__stdcall *SBServerSetCertStorageProc)(HANDLE hServer, HANDLE hCertStorage);
typedef BOOL (__stdcall *SBServerSetSessionPoolProc)(HANDLE hServer, HANDLE hSessionPool);
typedef BOOL (__stdcall *SBServerSetClientCertStorageProc)(HANDLE hServer, HANDLE hCertStorage);
typedef BOOL (__stdcall *SBServerEnableClientAuthenticationProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerDisableClientAuthenticationProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerIsClientAuthenticationEnabledProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerEnableForceCertificateChainProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerDisableForceCertificateChainProc)(HANDLE hServer);
typedef BOOL (__stdcall *SBServerIsForceCertificateChainEnabledProc)(HANDLE hServer);
typedef HANDLE (__stdcall *SBSessionPoolCreateProc)(void);
typedef BOOL (__stdcall *SBSessionPoolDestroyProc)(HANDLE hSessionPool);
typedef BOOL (__stdcall *SBSessionPoolSetTimeoutProc)(HANDLE hSessionPool, int Timeout);
typedef BOOL (__stdcall *SBSessionPoolSetIntervalProc)(HANDLE hSessionPool, int Interval);
typedef BOOL (__stdcall *SBSessionPoolSetMaxCountProc)(HANDLE hSessionPool, int MaxCount);
typedef BOOL (__stdcall *SetLicenseKeyProc)(PCHAR Key);



BOOL SBSSLSrvInitialize()
{
	if (InterlockedExchange(&nDllRefs, nDllRefs) > 0)
	{
		InterlockedIncrement(&nDllRefs);
		return TRUE;
	}
	else
	{
		hDll = LoadLibrary(DLL_NAME);
		if (hDll == NULL)
			return FALSE;
		InterlockedIncrement(&nDllRefs);
		for (int i = 0; i < DLL_ROUTINE_COUNT; i++)
		{
			aDllRoutines[i] = GetProcAddress(hDll, aDllRoutineNames[i]);
		}
		return TRUE;
	}
}

void SBSSLSrvFinalize()
{
	if (InterlockedExchange(&nDllRefs, nDllRefs) > 0)
	{
		if (InterlockedDecrement(&nDllRefs) == 0)
		{
			FreeLibrary(hDll);
			hDll = NULL;
		}
	}
}

BOOL SBSSLSrvSetLicenseKey(PCHAR Key)
{
	if (hDll == NULL) 
		return FALSE;
	else {
		((SetLicenseKeyProc)aDllRoutines[39])(Key);
		return TRUE;
	}
}

HANDLE	SBServerCreate(void)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBServerCreateProc)aDllRoutines[0])();
}

BOOL	SBServerDestroy(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDestroyProc)aDllRoutines[1])(hServer);
}

BOOL	SBServerOpen(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerOpenProc)aDllRoutines[2])(hServer);
}

BOOL	SBServerClose(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerCloseProc)aDllRoutines[3])(hServer);
}

BOOL	SBServerDataAvailable(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDataAvailableProc)aDllRoutines[4])(hServer);
}

BOOL	SBServerEnable(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerEnableProc)aDllRoutines[5])(hServer);
}

BOOL	SBServerDisable(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDisableProc)aDllRoutines[6])(hServer);
}

BOOL	SBServerEnableCipherSuite(HANDLE hServer, int nSuite)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerEnableCipherSuiteProc)aDllRoutines[7])(hServer, nSuite);
}

BOOL	SBServerDisableCipherSuite(HANDLE hServer, int nSuite)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDisableCipherSuiteProc)aDllRoutines[8])(hServer, nSuite);
}

BOOL	SBServerEnableVersion(HANDLE hServer, int nVersion)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerEnableVersionProc)aDllRoutines[9])(hServer, nVersion);
}

BOOL	SBServerDisableVersion(HANDLE hServer, int nVersion)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDisableVersionProc)aDllRoutines[10])(hServer, nVersion);
}

int		SBServerGetCurrentVersion(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerGetCurrentVersionProc)aDllRoutines[11])(hServer);
}

BOOL	SBServerIsEnabled(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerIsEnabledProc)aDllRoutines[12])(hServer);
}

BOOL	SBServerIsActive(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerIsActiveProc)aDllRoutines[13])(hServer);
}

BOOL	SBServerIsCipherSuiteEnabled(HANDLE hServer, int nSuite)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerIsCipherSuiteEnabledProc)aDllRoutines[14])(hServer, nSuite);
}

BOOL	SBServerIsVersionEnabled(HANDLE hServer, int nVersion)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerIsVersionEnabledProc)aDllRoutines[15])(hServer, nVersion);
}

int		SBServerGetCipherSuite(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerGetCipherSuiteProc)aDllRoutines[16])(hServer);
}

BOOL	SBServerSendData(HANDLE hServer, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSendDataProc)aDllRoutines[17])(hServer, pBuffer, nSize);
}

BOOL	SBServerSetOnData(HANDLE hServer, OnDataProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnDataProc)aDllRoutines[18])(hServer, pHandler, nUserData);
}

BOOL	SBServerSetOnReceive(HANDLE hServer, OnReceiveProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnReceiveProc)aDllRoutines[19])(hServer, pHandler, nUserData);
}

BOOL	SBServerSetOnSend(HANDLE hServer, OnSendProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnSendProc)aDllRoutines[20])(hServer, pHandler, nUserData);
}

BOOL	SBServerSetOnOpenConnection(HANDLE hServer, OnOpenConnectionProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnOpenConnectionProc)aDllRoutines[21])(hServer, pHandler, nUserData);
}

BOOL	SBServerSetOnCloseConnection(HANDLE hServer, OnCloseConnectionProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnCloseConnectionProc)aDllRoutines[22])(hServer, pHandler, nUserData);
}

BOOL	SBServerSetOnCertificateValidate(HANDLE hServer, OnCertificateValidateProc pHandler, int nUserData)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetOnCertificateValidateProc)aDllRoutines[23])(hServer, pHandler, nUserData);
}

BOOL	SBServerInternalValidate(HANDLE hServer, int* Validity, int* Reason)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerInternalValidateProc)aDllRoutines[24])(hServer, Validity, Reason);
}

BOOL	SBServerSetCertStorage(HANDLE hServer, HANDLE hCertStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetCertStorageProc)aDllRoutines[25])(hServer, hCertStorage);
}

BOOL	SBServerSetSessionPool(HANDLE hServer, HANDLE hSessionPool)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetSessionPoolProc)aDllRoutines[26])(hServer, hSessionPool);
}

BOOL	SBServerSetClientCertStorage(HANDLE hServer, HANDLE hCertStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerSetClientCertStorageProc)aDllRoutines[27])(hServer, hCertStorage);
}

BOOL	SBServerEnableClientAuthentication(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerEnableClientAuthenticationProc)aDllRoutines[28])(hServer);
}

BOOL	SBServerDisableClientAuthentication(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerDisableClientAuthenticationProc)aDllRoutines[29])(hServer);
}

BOOL	SBServerIsClientAuthenticationEnabled(HANDLE hServer)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBServerIsClientAuthenticationEnabledProc)aDllRoutines[30])(hServer);
}

BOOL	SBServerEnableForceCertificateChain(HANDLE hServer)
{
	if (hDll == NULL)
		return FALSE;
	else
		return((SBServerEnableForceCertificateChainProc)aDllRoutines[31])(hServer);
}

BOOL	SBServerDisableForceCertificateChain(HANDLE hServer)
{
	if (hDll == NULL)
		return FALSE;
	else
		return((SBServerDisableForceCertificateChainProc)aDllRoutines[32])(hServer);
}

BOOL	SBServerIsForceCertificateChainEnabled(HANDLE hServer)
{
	if (hDll == NULL)
		return FALSE;
	else
		return((SBServerIsForceCertificateChainEnabledProc)aDllRoutines[33])(hServer);
}

HANDLE	SBSessionPoolCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBSessionPoolCreateProc)aDllRoutines[34])();
}

BOOL	SBSessionPoolDestroy(HANDLE hSessionPool)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBSessionPoolDestroyProc)aDllRoutines[35])(hSessionPool);
}

BOOL	SBSessionPoolSetTimeout(HANDLE hSessionPool, int nTimeout)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBSessionPoolSetTimeoutProc)aDllRoutines[36])(hSessionPool, nTimeout);
}

BOOL	SBSessionPoolSetInterval(HANDLE hSessionPool, int nInterval)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBSessionPoolSetIntervalProc)aDllRoutines[37])(hSessionPool, nInterval);
}

BOOL	SBSessionPoolSetMaxCount(HANDLE hSessionPool, int nMaxCount)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBSessionPoolSetMaxCountProc)aDllRoutines[38])(hSessionPool, nMaxCount);
}
